const WL_Wiktionary_section_names = [
    "Abbreviation",
    "Acronym",
    "Adjective",
    "Adverb",
    "Anagrams",
    "Article",
    "Cardinal number",
    "Cardinal numeral",
    "Compounds",
    "Conjugation",
    "Conjunction",
    "Contraction",
    "Counter",
    "Declension",
    "Descendants",
    "Determiner",
    "Hiragana",
    "Idiom",
    "Infix",
    "Inflection",
    "Initialism",
    "Interjection",
    "Noun",
    "Number",
    "Numeral",
    "Ordinal number",
    "Ordinal numeral",
    "Participle",
    "Particle",
    "Phrase",
    "Pinyin syllable",
    "Prefix",
    "Preposition",
    "Pronoun",
    "Proper noun",
    "Proverb",
    "Quotations",
    "Romaji",
    "Trivia",
    "Verb",
    "Verb form"
];

/**
* Create a new English Wiktionary handler and tie it to the WikiLook interface
**/
function WikiLook_en (WikiLook) {
  
    this.WL = WikiLook
  
}

/**
 * This checks the current entry to see if it is a "form of" another word.
 * If it is then we download the word of which it is a form and append that
 * to the display.
**/
WikiLook_en.prototype.formOf = function () {

    //if (this.WL._outText.indexOf("spelling of")!=-1) {alert(this.WL._outText.substring(this.WL._outText.indexOf("spelling of"),this.WL._outText.indexOf("spelling of")+350));}
    
    //Only allow an extra two formOf's to be added
    if (this.WL._thisIsAFormOfFormOf == true) 
      return;
      
    if (this.WL._thisIsAFormOf == true) 
      this.WL._thisIsAFormOfFormOf = true;

    var wordtemp="";
    var word="";
    
    //This is the current contents of the form of templates, lets hope they don't change
    var pattern = 'form of <span class="mention"><a style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://en.wiktionary.org/wiki/';
      //           'form of <span class="mention"><a style="color:#002BB8;font-weight:normal;font-size:12px;" href="/wiki/'
      
    //Extract the word of which we are a form
    var a = this.WL._outText.indexOf(pattern);
    
    
    if (a!=-1) {
        word=this.WL._outText.substring(a+pattern.length, this.WL._outText.indexOf('" title="',a));
        wordtemp=word.substring(0,word.indexOf("#"));
    }
    
    if (word!="") {
        if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
        this.WL._thisIsAFormOf=true;
        this.WL._currentWord=word;
        this.WL.requestFetchWord2(word);
        return;
    }
    //Repeat for other form of s that we've found
    word="";
    wordtemp="";
    pattern = 'spelling of <span class="mention"><a style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://en.wiktionary.org/wiki/';
    var a = this.WL._outText.indexOf(pattern);
    if (a!=-1) {
        word=this.WL._outText.substring(a+pattern.length, this.WL._outText.indexOf('" title="',a));
        wordtemp=word.substring(0,word.indexOf("#"));
    }
    if (word!="") {
        if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
        this.WL._thisIsAFormOf=true;
        this.WL._currentWord=word;
        this.WL.requestFetchWord2(word);
        return;
    }
    
    
    
    word="";
    wordtemp="";
    pattern = 'state of being <a style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://en.wiktionary.org/wiki/';
    var a = this.WL._outText.indexOf(pattern);
    if (a!=-1) {
        word=this.WL._outText.substring(a+pattern.length, this.WL._outText.indexOf('" title="',a));
        wordtemp=word.substring(0,word.indexOf("#"));
    }
    if (word!="") {
        if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
        this.WL._thisIsAFormOf=true;
        this.WL._currentWord=word;
        this.WL.requestFetchWord2(word);
        return;
    }
        
    word="";
    wordtemp="";
    pattern = 'participle of <span class="mention"><a style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://en.wiktionary.org/wiki/';
    var a = this.WL._outText.indexOf(pattern);
    if (a!=-1) {
        word=this.WL._outText.substring(a+pattern.length, this.WL._outText.indexOf('" title="',a));
        wordtemp=word.substring(0,word.indexOf("#"));
    }
    if (word!="") {
        if (word.length>wordtemp.length&&wordtemp.length>0) {
            word=wordtemp;
        }
        this.WL._thisIsAFormOf=true;
        this.WL._currentWord=word;
        this.WL.requestFetchWord2(word);
        return;
    }
    
    word="";
    wordtemp="";
    pattern = 'past of <span class="mention"><a style="color:#002BB8;font-weight:normal;font-size:12px;" href="http://en.wiktionary.org/wiki/';
    var a = this.WL._outText.indexOf(pattern);
    if (a!=-1) {
        word=this.WL._outText.substring(a+pattern.length, this.WL._outText.indexOf('" title="',a));
        wordtemp=word.substring(0,word.indexOf("#"));
    }
    if (word!="") {
        if (word.length>wordtemp.length&&wordtemp.length>0){word=wordtemp;}
        this.WL._thisIsAFormOf=true;
        this.WL._currentWord=word;
        this.WL.requestFetchWord2(word);
        return;
    }
}
