/*************************
 * WikiLook.js
  * Author: TestPilot
 *
  *************************/
var db_pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

//////////////////////////////////////////////////////////////////////
// Data
//////////////////////////////////////////////////////////////////////

const WL_WikiLook = ",Wikilook,wikilook,WikiLook,"; 

//////////////////////////////////////////////////////////////////////
// Core Object
//////////////////////////////////////////////////////////////////////

WikiLook = function () {
    
    //Load up the English Wiktionary parser thingy..
    this._en_wikt = new WikiLook_en (this)
    
	this._WL_initialized = false;
	this._WL_enabled = true;
	this._WL_ID = null;
	this._wordMonTimer = null;	// word monitor timer object
	this._mainWindow = null;
	this._currentDoc = null;
	this._shiftKey = null;
	this._initialized = true;
	this._eventRangeParent = null;
	this._eventRangeOffset = null;
	this._eventTarget = null;
	this._event = null;
	this._eventClientX = null;
	this._eventClientY = null;
	this._wordX = null;
	this._wordY = null;
	this._currentWord = "";
	this._lastWord = "";
	this._wordMonTimer = null;
	this._pref_WordMonTimerDelay = 1000;	// in miliseconds
	this._pref_HideWhenMouseMove = false;	// hide definition when mouse moves
	this._pref_WindowOffsetX = 6;		
	this._pref_WindowOffsetY = 3;		
	this._pref_BlockBasicWords = true;		
	this._divId = "WikiLook_overlay_layout";
	this._div = null;
	this._divIsDisplayed = false;
	this._showDefinition = false;
	this._isRequestFetching = false;
	this._statusImageId = "WikiLook_StatusImage";
    this._mainLanguage = "English";
	this._mainLngFound = false;
	this._defFound = false;
	this._goForIt = false;
	this._thisIsAFormOf=false;
	this._thisIsAFormOfFormOf=false; //let entries like [[realised ]], past form of [[realise]], alternate spelling of [[realize]], but still preventing more then 3 form of look ups
	this._outText = "";
	// color schemes
	this._linkColor = "#002BB8";
//	this._backgroundColor = "#C5FCDC";
	this._backgroundColor = "#BDFEDC";
	// AJAX object
	this._request = null;	

	// preference object
	this._pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	this.init();
}

/**
 * Called at the end of constructor to finalize object...
**/
WikiLook.prototype.init = function() {
	if (this._WL_initialized == true) {
		return;
	}
	this._WL_initialized = true;
	this._WL_ID = ((new Date).getTime()).toString();

}


//////////////////////////////////////////////////////////////////////
// Global Raw Functions & Objects
//////////////////////////////////////////////////////////////////////

var WL_request = Object;

//////////////////////////////////////////////////////////////////////
// Event Handlers
//////////////////////////////////////////////////////////////////////

WikiLook.prototype.eventLoad = function(event) { WikiLook_Overlay.eventLoadImpl(event); } // fires once on each browser window open
WikiLook.prototype.eventLoadImpl = function(event) {
	this.loadPref();
	this.updateStatusImage();
	var FirstRun = db_pref.getBoolPref("WikiLook.FirstRun");
	if (FirstRun) {
	window.setTimeout(function() {
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	    	var wmed = wm.QueryInterface(Components.interfaces.nsIWindowMediator);
 	    	var win = wmed.getMostRecentWindow("navigator:browser");
			var content = win.document.getElementById("content");
	    	content.selectedTab = content.addTab("http://wikilook.mozdev.org/"); //this is help page are/will describe how to use WikiLook	
			db_pref.setBoolPref("WikiLook.FirstRun", false);
		}, 1250);
	}
}

WikiLook.prototype.eventUnload = function(event) { WikiLook_Overlay.eventUnloadImpl(event); } // fires once on each browser window close
WikiLook.prototype.eventUnloadImpl = function(event) {
}

WikiLook.prototype.eventFocus = function(event) { WikiLook_Overlay.eventFocusImpl(event); }
WikiLook.prototype.eventFocusImpl = function(event) {
	//this.clearAll();
	this._currentDoc = event.target;

}

WikiLook.prototype.eventBlur = function(event) { WikiLook_Overlay.eventBlurImpl(event); }
WikiLook.prototype.eventBlurImpl = function(event) {
	//this.clearAll();
}

WikiLook.prototype.eventClick = function(event) { WikiLook_Overlay.eventClickImpl(event); }
WikiLook.prototype.eventClickImpl = function(event) {
	this._currentDoc = this.getDoc(event);

	// Check whether the click is made in WikiLook window
	// to avoid "nullifying click" inside the WikiLook
	var isInWL_div = false;
	if (event.target.tagName == "A")
	{
		var p = event.target;
		var sentinel = 0;
		while (p.tagName != "HTML"  && isInWL_div == false)	{
			sentinel++;
			p = p.parentNode;
			if(sentinel>20) {
				return;
			}
		};
	}
	if (isInWL_div == false)
	{
		this.clearAll();
	}

}
 
WikiLook.prototype.eventMouseMove = function(event) { WikiLook_Overlay.eventMouseMoveImpl(event); }
WikiLook.prototype.eventMouseMoveImpl = function(event) {
	if (!this._WL_enabled) return;
	if (this._pref_HideWhenMouseMove || this._isRequestFetching ) {
		//if (this._defFound) return;
		if (this._defFound==false) this.clearAll();
		this.clearWordMonTimer();
	} else {
		this.clearWordMonTimer();
		//this.clearRequest();
	}

	// WL_currentDoc = event.target.ownerDocument;
	this._currentDoc = this.getDoc(event);
	this._eventTarget = event.target;
	//if ( this._eventTarget.tagName != "SELECT") {
		this._eventRangeParent = event.rangeParent;
		this._eventRangeOffset = event.rangeOffset;
		this._eventClientX = event.clientX;
		this._eventClientY = event.clientY;
		this._shiftKey = event.shiftKey;
		this._wordMonTimer = setTimeout("WikiLook_Overlay.MouseMoveMon()",this._pref_WordMonTimerDelay);
	
	//}
	
}

WikiLook.prototype.eventScroll = function(event) { WikiLook_Overlay.eventScrollImpl(event); }
WikiLook.prototype.eventScrollImpl = function(event) {
	if (!this._WL_enabled) return;
	//this.clearAll();
}

WikiLook.prototype.eventClickStatus = function(event) { WikiLook_Overlay.eventClickStatusImpl(event); }
WikiLook.prototype.eventClickStatusImpl = function(event) {
	if (event.button == 0){ //left click
		this._WL_enabled = !this._WL_enabled;
		db_pref.setBoolPref("WikiLook.WL_enabled", this._WL_enabled);
		
		// when turned off
		if (!this._WL_enabled) {
			this._pref.setBoolPref("extensions.wikilook.enabled", this._WL_enabled);
			this.clearAll();
			this.removeDiv();
		}
		this.updateStatusImage();
	}
}

//////////////////////////////////////////////////////////////////////
// Core Functions
//////////////////////////////////////////////////////////////////////

WikiLook.prototype.updateStatusImage = function() {
	var img =  document.getElementById(this._statusImageId);
	if (this._WL_enabled) {
		img.src = "chrome://wikilook/skin/wiki_on.gif";
	} else {
		img.src = "chrome://wikilook/skin/wiki_off.gif";
	}
}

WikiLook.prototype.loadPref = function() {
	//this._pref.getCharPref
	//this._pref.setCharPref
	//this._pref.getBoolPref
	//this._pref.setBoolPref
	this._WL_enabled = db_pref.getBoolPref("WikiLook.WL_enabled");
	
	/*try	{ this._pref_WordMonTimerDelay = parseInt(this._pref.getCharPref("extensions.wikilook.wordmondelay"));
	} catch (e)	{	this._pref.setCharPref("extensions.wikilook.wordmondelay",this._pref_WordMonTimerDelay);
	}

	try	{ this._WL_enabled = this._pref.getBoolPref("extensions.wikilook.enabled");
	} catch (e)	{ this._pref.setBoolPref("extensions.wikilook.enabled",true);
	}*/

}

WikiLook.prototype.clearAll = function() { // get ready for new state
	this._thisIsAFormOf=false;
	this._thisIsAFormOfFormOf=false;
	this._showDefinition=false;
	this._goForIt=false;
	this._mainLngFound=false;
	this._defFound = false;
	this.clearWordMonTimer();
	this.clearRequest();
	this.clearDisplay();
	this._currentDoc = null;
	this._currentWord = null;
	this._lastWord = null;
	this._shiftKey = null;
}

WikiLook.prototype.clearWordMonTimer = function() {
	if (this._wordMonTimer != null) {
		clearTimeout(this._wordMonTimer);
		this._wordMonTimer = null;
	}
}

WikiLook.prototype.clearDisplay = function() {
	this.removeDiv();
	this._showDefinition = false;
}

WikiLook.prototype.clearRequest = function () {
	if (this._isRequestFetching) {
		this._isRequestFetching = false;
	}
	if (WL_request != null)	{
		try {
			WL_request.abort();	
		}
		catch (e) {
		}
		WL_request = null
	}
}

WikiLook.prototype.getDoc = function(event) {
	return event.target.ownerDocument;
	return window._content.document;
	return content.document;
	return //WL_currentDoc = content.document;
}

WikiLook.prototype.MouseMoveMon = function() { // Mouse Movement Monitor
	if (!this._WL_enabled) return;

	//this.clearRequest();

	this._currentWord = this.getCurrentWord(this._eventRangeParent,this._eventRangeOffset,this._eventTarget);
	if (this._currentWord == null || this._currentWord.length < 2) return;
	this._currentWord = this.trim(this._currentWord);

	if (this._pref_BlockBasicWords) {
		if (WL_WikiLook.indexOf(","+this._currentWord+",") != -1) {
			this._showDefinition = true;
			this._isRequestFetching = true;
			if(!this.attachDiv()) return;
			this._div.style.left = this.getNewWindowX() + "px";
			this._div.style.top = this.getNewWindowY() + "px";
			this._div.innerHTML = "WikiLook is your favourite FireFox Add-on:)";
			this.showDiv();
			return;
		}
	}

	// Valid word?
	if ( this._currentWord != null && this.isWord(this._currentWord) && this._currentWord.length > 1) {
		if (this._lastWord == this._currentWord ) return;
		this._lastWord = this._currentWord;
		this._currentWord=this._currentWord.replace(/'s$/, "" )
		this._currentWord=this._currentWord.replace(/’s$/, "" )
		// killing ' around words
		this._currentWord=this._currentWord.replace(/'(\S+)'/g, "$1")
		//this._currentWord=this._currentWord.replace(/\s'/g, "" )
		this._currentWord=this._currentWord.replace(/"/g, "" )
		this._currentWord=this._currentWord.replace(/'/, "%27" )
		this._showDefinition = true;
		if(!this.attachDiv()) return;
		this._div.style.left = this.getNewWindowX()+"px";
		this._div.style.top = this.getNewWindowY()+"px";
		this._div.innerHTML = "(looking up <b>"+ this._currentWord.replace("%27","\'" ) +"</b> from Wiktionary.org ...)";
		this.showDiv();
		this._isRequestFetching = true;
		//this._defFound = false;
 		if(!this.requestFetchWord(this._currentWord)){
			// No article?
			
		}
	}
}

WikiLook.prototype.getNewWindowX = function () {
	if (this._eventClientX + 400  + this._pref_WindowOffsetX > this._currentDoc.width ) {
		return (this._currentDoc.width - 400 > 0) ? (this._currentDoc.width - 400) : 0;
	}
	else {
		return this._eventClientX + this._pref_WindowOffsetX;
	}
}

WikiLook.prototype.getNewWindowY = function () {
	return this._eventClientY + this._currentDoc.documentElement.scrollTop + this._currentDoc.body.scrollTop + this._pref_WindowOffsetY;
}

WikiLook.prototype.showDiv = function () {
	if (this._div != null && this._showDefinition == true) {
		this._div.style.display="block";
		//this._div.style.display="inline";
		this._divIsDisplayed = true;
	}
}

WikiLook.prototype.hideDiv = function() {
	if (this._div != null) {
		this._div.style.display="none";
	}
	this._divIsDisplayed = false;
}

WikiLook.prototype.attachDiv = function() {
	//this.removeDiv();
	if (this._showDefinition == false) {
		return false;
	}
	if (this._thisIsAFormOf==true) {
		return true;
	}
	var div;
	try {
		div=this._currentDoc.createElementNS("http://www.w3.org/1999/xhtml","XHTML");	
	} catch (e) {
		return false;
	}
	div.id = this._divId;
	//div.style.inline;
	div.style.position = "absolute";
	//div.style.left = "100px";
	//div.style.top = "200px";
	//div.style.height = "20px";
	div.style.maxWidth = "450px";
	div.style.lineHeight = "2.2";
	div.style.textAlign = "left";
	// try being defined by WikiLook.css in content 
	//div.className = "WikiLook_overlay_class";
	div.style.color = "#000000";
	div.style.fontSize = "12px";
	div.style.fontWeight = "normal";
	div.style.fontStyle = "normal";
	div.style.fontFamily = "arial,verdana,sans-serif";
	div.style.fontSizeAdjust = "none";
	div.style.fontStretch = "normal";
	div.style.fontVariant = "normal";
	div.style.lineHeight = "10px";
	div.style.backgroundColor = this._backgroundColor;
	div.style.background = this._backgroundColor;
	div.style.border = "2px solid #6EF7A7";
	div.style.borderBottomStyle = "outset";
	div.style.borderRightStyle = "outset";

    div.style.outlineColor = "#6EF7A7";
	
	div.style.margin = "2px 2px 2px 2px";
	div.style.padding = "3px 3px 3px 3px";
	div.style.cssFloat = "none";
	div.style.overflow = "hidden";
	div.style.zIndex = "32710";
	div.style.display = "none";
	div.style.verticalAlign = "middle";
	div.style.paddingStart = "5px";
	div.setAttribute('align', 'left');

	this._currentDoc.body.appendChild(div);
	this._div = this._currentDoc.getElementById(this._divId);
	this._div.className = "WikiLook_overlay_class";
	return true;
}

WikiLook.prototype.removeDiv = function() {

	if (this._div != null) {
		try {
			this._currentDoc.body.removeChild(WL_div);
		}
		catch (err) {
		}
		this._divIsDisplayed = false;
		this._div = null;
	}

	try {
		if (this._currentDoc.getElementById(this._divId) != null) {
			var t=this._currentDoc.getElementById(this._divId).parentNode;
			t.removeChild(this._currentDoc.getElementById(this._divId));
			this._currentDoc.removeChild(this._divId);
		}
	}
	catch (err) {
	}
	this._divIsDisplayed = false;
	this._div = null;
}

WikiLook.prototype.toCapitalCaseWL = function(words) {
var re = /\s/;
words = words.split(re);
re = /(\S)(\S+)/;
for (i = words.length - 1; i >= 0; i--) {
re.exec(words[i]);
words[i] = RegExp.$1.toUpperCase()
+ RegExp.$2.toLowerCase();
}
return words.join(' ');
}


WikiLook.prototype.responseFetchReal = function (response) {
	//this._isRequestFetching = false;
	//var defFound = false;
	if (response.indexOf("Wiktionary does not yet have an entry for") == -1) {
///////////////////////
		var pattern="wiktionary.org/w/index.php?title=";
		var titleStarts=response.indexOf(pattern)
		var TitleName=response.substring(titleStarts+pattern.length, response.indexOf("&amp;action=",titleStarts+pattern.length));
//		if (TitleName.length>TitleNameTemp.length) {TitleName=TitleNameTemp;}
//		alert(TitleName);
///////////////////////
		var lngName="";
		var mlngstrStarts='id="'+this._mainLanguage+'"></a></p>';
		var mlngstrStops='<h2><span class="editsection">[<a ';
		var mlngStart=response.indexOf(mlngstrStarts)+mlngstrStarts.length+1;
		if (mlngStart-mlngstrStarts.length-1==-1) {
			mlngStart=response.indexOf(mlngstrStops);
			if (this._goForIt==true&&this._defFound==true) {
				this._en_wikt.formOf();
				return true;
			}
		} else {this._mainLngFound=true;}
		var mlngStops=response.indexOf(mlngstrStops, mlngStart+1);
		var tmp=response.substring(0,mlngStart);
		var nameStarts=tmp.lastIndexOf('" id="')+6;
		lngName=tmp.substring(nameStarts,mlngStart-11);
		if (mlngStops!=-1){
			response=response.substring(mlngStart,mlngStops);
		}
////////////////////////
		this._outText = "";
		var sectionName = "";
		var secIdx=0;
		for(secIdx=0; secIdx < WL_Wiktionary_section_names.length; secIdx++) {
			sectionName = WL_Wiktionary_section_names[secIdx];
			r = false;
			r = this.wiktionaryGetSection(response,sectionName);
			if (r != false) {
				this._outText += "<b>"+sectionName+"</b>"+r;
			}
		}
		if (this._defFound) {
			this._outText = this.wiktionarySetStyle(this._outText);
			if(!this.attachDiv()) return;
			tStem = "";
			if (this._thisIsAFormOf==false) {
				this._div.style.left = this.getNewWindowX() + "px";
				this._div.style.top =this.getNewWindowY() + "px";
			}
			// This is very strange - but next line needed so redirects from proper noun that starts with lower case are shown correctly, while not touching the way words in weird alphabets are shown, like ones in Amharic.
			if (this._currentWord.length==TitleName.length) {this._currentWord=TitleName}
			if (this._thisIsAFormOf==false) { 
				this._div.innerHTML = ""; 
			} else {
				this._div.innerHTML =this._div.innerHTML +'<center><hr width="80%" align="center" border="2" noshade color="#F5F5F5"><\center><\hr><br>'; 
				//this._thisIsAFormOf=false;
			}
			this._div.innerHTML =this._div.innerHTML + "<b ><a style=\"color:"+this._linkColor+";\" href='http://en.wiktionary.org/wiki/"+this._currentWord+"' style='font-size:12px;'>"+this._currentWord.replace("%27","\'").replace(/_/g," ")+"</a></b> "
								+" &nbsp;" + tStem
								+'<b><i><font size=-5 color=#660033>'+lngName.replace(/_/g," ")+' </font></b></i>&nbsp;( Look up "'+ this._currentWord.replace("%27","\'" ).replace(/_/g," ") +'" in '
								+" <a style=\"color:"+this._linkColor+";\" href='http://www.wikipedia.org/wiki/"+this._currentWord+"'>Wikipedia</a> "
								+" )<br/><br/>"
								+"<span style=\"display:block;font-family:arial;\">"
								+this._outText
								+"</span>";
								+"(retrieved from <a style=\"color:"+this._linkColor+";\" href=http://www.wiktionary.org>wiktionary.org</a>)";
			if((this._goForIt==true&&this._defFound==true)||(this._mainLngFound==true&&this._defFound==true)){
				//this.removeDiv();
				this.showDiv();
				this._en_wikt.formOf();
				return true;
				}
			return false;
		} else {
			return false;
		}
	} else { 
		if (response.indexOf('<li><big>Did you mean <b><span id="did-you-mean"><a href="/wiki/')!=-1) {
			var a=response.indexOf('<li><big>Did you mean <b><span id="did-you-mean"><a href="/wiki/');
			var pattern='" title="';
			var titleStarts=response.indexOf(pattern,a)
			var TitleName=response.substring(titleStarts+pattern.length, response.indexOf('">',titleStarts+pattern.length));
			this._isRequestFetching = true;
			this._currentWord=TitleName;
			this.requestFetchWord2(TitleName);
			return true;
		}
		
	}
	return false;
}


WikiLook.prototype.responseFetch2 = function (response) {
	this._goForIt=true;
	if (this.responseFetchReal(response)==true){
	    //this._defFound=false;
		return;
	}	else {
			// unable to parse the content
			if(!this.attachDiv()) return;
			this._div.style.left = this.getNewWindowX() + "px";
			this._div.style.top = this.getNewWindowY() + "px";
			this._div.innerHTML = "* Unable to parse the <a style=\"color:"+this._linkColor+";\" href='http://www.wiktionary.org/wiki/"+this._lastWord+"'>"+this._lastWord+"</a> from <a  href=http://www.wiktionary.org>wiktionary.org</a>";
			this.showDiv();
			//Killing "unable to parse" div in  1 sec
			setTimeout(function(something) { return function() { something.removeDiv(); }; }(this), 1000);
			//this._defFound=false;
	}
	
}



WikiLook.prototype.responseFetch = function (response) {
	this._defFound=false;
	this._mainLngFound=false;
	this._goForIt=false;
	this._thisIsAFormOf=false;
	this._thisIsAFormOfFormOf=false;
	if (this.responseFetchReal(response)==true){
		//this._defFound = false;
		return;
	}	else {
			if (this._currentWord==this._currentWord.toUpperCase()) {
				this._currentWord=this._currentWord.toLowerCase();
			} else {
				if (this._currentWord==this.toCapitalCaseWL(this._currentWord)) {
					this._currentWord=this._currentWord.toLowerCase();
				} else {
					this._currentWord=this.toCapitalCaseWL(this._currentWord);
				};
			}
			if (this._defFound == false) {this._isRequestFetching = true; }
			this.requestFetchWord2(this._currentWord);
			//this._defFound = false;
	}

	//this._defFound = false;
	return;
}




WikiLook.prototype.requestFetchWord = function (word) {


	try	{
		WL_request = new XMLHttpRequest();
		if (WL_request.readyState != 0) {
			return;
		}
		var url="http://en.wiktionary.org/wiki/"+ word;
		WL_request.open("GET", url, true);
		WL_request.send(null);
	}
	catch (e)	{
		return;
	}

	WL_request.onreadystatechange = function() {
		if (WL_request!=null) {
			if (WL_request.readyState == 4) {
				if (WL_request.status==200) {
					WikiLook_Overlay.responseFetch(WL_request.responseText);
				}
				else {
				}
			}
		}
	}
}

WikiLook.prototype.requestFetchWord2 = function (word) {
	try	{
		WL_request = new XMLHttpRequest();
		if (WL_request.readyState != 0) {
			return;
		}
		var url="http://en.wiktionary.org/wiki/"+ word;
		WL_request.open("GET", url, true);
		WL_request.send(null);
	}
	catch (e)	{
		return;
	}

	WL_request.onreadystatechange = function() {
		if (WL_request!=null) {
			if (WL_request.readyState == 4) {
				if (WL_request.status==200) {
					WikiLook_Overlay.responseFetch2(WL_request.responseText);
				}
				else {
				}
			}
		}
	}
}



WikiLook.prototype.wiktionaryGetSection = function (sourceText,sectionName) {
	// Convert to lowercase to find pattern position.
	// Discard lowercase needle and hay later.
	var sNameLower = sectionName.replace(" ","_","ig"); //.toLowerCase();
	var patternLower = "<a name=\"" + sNameLower + "\" id=\"" + sNameLower + "\"></a></p>";
	var sourceLower = sourceText;//.toLowerCase();
	var headPos = sourceLower.indexOf(patternLower);
	if ( headPos != -1 ) {
		this._defFound = true;
		var u = sourceText.substring(headPos+patternLower.length);
		u = this.cutHead_preserve("<ol>", u);
		if (u==null) {return false;}
		u = this.cutTail_preserve("</ol>", u);
		u = u.replace(" href=\""," href=\"http://en.wiktionary.org", "gi");
		return u;
	}
	return false;
}

WikiLook.prototype.wiktionarySetStyle = function (stxt) {
	var nomargin = "color:#000000;padding:0px 1px 1px 1px;margin:1px 1px 1px 4px;font-weight:normal;";
	stxt = stxt.replace("<ol>","<ol style='padding:2px 2px 2px 10px;margin:2px 2px 2px 10px;'>","gi");
	stxt = stxt.replace("<dl style='","<dl style='"+nomargin+";","gi");
	stxt = stxt.replace("<dl>","<dl style='"+nomargin+";'>","gi");
	stxt = stxt.replace("<dd style='","<dd style='"+nomargin+";","gi");
	stxt = stxt.replace("<dd>","<dd style='"+nomargin+";'>","gi");
	stxt = stxt.replace("<li style='","<li style='"+nomargin+";font-family:arial;","gi");
	//Next lines are non essential lines that looks for "lazy mans" inclusion of context labels, ones that defined not by tamplate, but by parentheses. 
	stxt = stxt.replace(/<li>\(<i>([^\)]*)<\/i>\)/g, "<li><i><font size=-7 color=\"purple\">($1)</font></i>");
    stxt = stxt.replace(/<li>(\([^\)]*\))/g, "<li><i><font size=-7 color=\"purple\">$1</font></i>");
	//Formatting  actual context labels
	stxt = stxt.replace(/<span class="ib-comma"><span class="qualifier-comma">,<\/span><\/span>/g, ",");

	//to fix font size /color of links inside parenteses
	stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a style=\"color:brown;font-size:9px;\" href=$3)"); 
	stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a style=\"color:brown;font-size:9px;\" href=$3)"); 
	stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\((.[^\)]*?)(<a href=)(.*?)\)/g, "<span class=\"ib-brac\"><span class=\"qualifier-brac\">($1<a style=\"color:brown;font-size:9px;\" href=$3)"); 

	
	stxt = stxt.replace(/<span class="ib-brac"><span class="qualifier-brac">\(<\/span><\/span><span class="ib-content"><span class="qualifier-content">(.*?)<\/span><\/span><span class="ib-brac"><span class="qualifier-brac">\)<\/span><\/span>/g, "<i><font size=-7 color=\"purple\">($1)</font></i>"); 
	stxt = stxt.replace("<li>","<li style='"+nomargin+";font-family:arial;list-style-image:none;line-height:100%;background-color:"+this._backgroundColor+";'>","gi");
	stxt = stxt.replace("<i>","<i style='color:#000000;font-weight:normal;font-family:arial;list-style-type:none;line-height:100%;background-color:"+this._backgroundColor+"'>","gi");

	//fixinf heperlink font size/color of the  links
	stxt = stxt.replace(/ href=/g, " style=\"color:"+this._linkColor+";font-weight:normal;font-size:12px;\" href="); 
	
	return stxt;
}



// Derived & Modified from BackWord
WikiLook.prototype.getCurrentWord = function(parent, offset, target) {



	var container = parent.parentNode;

	if (container) {

			var foundNode = false;

			for (var c = container.firstChild; c != null; c = c.nextSibling) {

					if (c == parent) {

							foundNode = true;

							break;

					}

			}

			if (!foundNode) {

					return null;

			}

	}

	var range = parent.ownerDocument.createRange();

	range.selectNode(parent);

	var str = range.toString();

	if (offset < 0 || offset >= str.length) {

			return null;

	}

	var start = offset;

	var end = offset + 1;

	var valid_chars = /[a-zA-Zа-яА-Яà-žΑ-ῥԱ-ևぁ-ヶ促-杁ㄱ-하ⁿ'’ſÁÉ-]/;

	if (!valid_chars.test(str.substring(start, start + 1))) {

			return null;

	}

	while (start > 0) {

			if (valid_chars.test(str.substring(start - 1, start))) {

					start--;

			} else {

					break;

			}

	}

	while (end < str.length) {

			if (valid_chars.test(str.substring(end, end + 1))) {

					end++;

			} else {

					break;

			}

	}

	var prottext = str.substring(start, end);

	if (prottext.length<2) { 

		return null;

	}

	if (this._shiftKey) {

		return prottext;

	}

	var selection = document.commandDispatcher.focusedWindow.getSelection();

	var mouseInSelection = (!selection.isCollapsed && selection.getRangeAt(0).isPointInRange(parent, offset));

	var selectedText = selection.toString();

	if (selectedText.length>50) { 

		return null;

	}

	if (mouseInSelection) {return selectedText;};

	

};


WikiLook.prototype.plainText = function(text_) {
    var text = WL_HTMLEncode(text_);
    text = text.replace(/\n/g, "<BR />");
    return text;
}
WikiLook.prototype.HTMLEncode = function(text) {
    text = text.replace(/&/g, "&amp;");
    text = text.replace(/"/g, "&quot;");
    text = text.replace(/</g, "&lt;");
    text = text.replace(/>/g, "&gt;");
    text = text.replace(/'/g, "&#146;");
    return text;
}
WikiLook.prototype.HTMLDecode = function(text) {
    text = text.replace(/&amp;/g, "&");
    text = text.replace(/&quot;/g, "\"");
    text = text.replace(/&lt;/g, "<");
    text = text.replace(/&gt;/g, ">");
    text = text.replace(/&#146;/g, "'");
    text = text.replace(/<BR \/>/g, "\n");
    return text;
}
WikiLook.prototype.isWord = function(str){
	var i=0;
	for(; i<str.length; i++){
		if (!this.isAlphabet(str.substr(i, 1))) {
			return false;
		}
	}
	return true;
}

WikiLook.prototype.isAlphabet = function(str){
	var valid_chars = /[a-zA-Zа-яА-Яà-žΑ-ῥԱ-ևぁ-ヶ促-杁ㄱ-하ⁿ'’ſÁÉ-]/;
//	return valid_chars.test(str);
    return true;
}

WikiLook.prototype.isAlphaNumeric = function(str){
//    use locale;
	var valid_chars = /[a-zA-Zа-яА-Яà-žΑ-ῥԱ-ևぁ-ヶ促-杁ㄱ-하ⁿ'’ſÁÉ-]/;
//	return valid_chars.test(str);
	return true;
}

WikiLook.prototype.getTop = function(div){
	return parseInt(div.style.top.substr(0, div.style.top.length-2))
}

WikiLook.prototype.getLeft = function(div){
	return parseInt(div.style.left.substr(0, div.style.left.length-2))
}

WikiLook.prototype.stripHTML = function(oldString) {
	var newString = "";
	var inTag = false;
	for(var i = 0; i < oldString.length; i++) {
		if(oldString.charAt(i) == '<') inTag = true;
		if(oldString.charAt(i) == '>') {
			inTag = false;
			i++;
		}
		if(!inTag) newString += oldString.charAt(i);
	}
	return newString;
}

WikiLook.prototype.stripTags = function(oldString) {
	return oldString.replace(/(<([^>]+)>)/ig,"");
}


WikiLook.prototype.cutHead_preserve = function(strPattern, oldString) {
	i = oldString.indexOf(strPattern);
	if (i==-1) {
		return null;
	} else {
		return oldString.substring(i);
	}
}


WikiLook.prototype.cutTail_preserve = function(strPattern, oldString) {
	i = oldString.indexOf(strPattern);
	if (i==-1) {
		return null;
	} else {
		return oldString.substring(0, i + strPattern.length);
	}
}

/**
 *Trim whitespace from the edges of strings
**/
WikiLook.prototype.trim = function (str) {
    //removes 
    // the start (^) followed by lots of whitespace (s+)
    // or (|) 
    // lots of whitespace (s+) followed by the end ($)
  	return str.replace (/^\s+|\s+$/g, "");
}

/**
WikiLook.prototype.trim = function(str){

	return this.ltrim(this.rtrim(str));
}

WikiLook.prototype.rtrim = function(str){
	var v_length = str.length;
	if(v_length < 0) {
		return "";
	}
	var w_space = String.fromCharCode(32);
	var strTemp = "";
	var iTemp = v_length -1;
	while(iTemp > -1) {
		if(str.charAt(iTemp) == w_space) {
			// do nothing
		}
		else
		{	strTemp = str.substring(0,iTemp +1);
			break;
		}
		iTemp = iTemp-1;
	} //End While
	return strTemp;
} //End Function

WikiLook.prototype.ltrim = function(str){
	var w_space = String.fromCharCode(32);
	var v_length = str.length;
	if(v_length < 1){
		return "";
	}
	var strTemp = "";
	var iTemp = 0;
	while(iTemp < v_length){
		if(str.charAt(iTemp) == w_space){
			//do nothing
		}
		else{
			strTemp = str.substring(iTemp,v_length);
			break;
		}
		iTemp = iTemp + 1;
	} //End While
	return strTemp;
} //End Function
**/


